{<skip/>}
var
  long _motor_cruise,_zerol,_zeror,_gainl,_gainr,_ngainl,_ngainr,_coast
'a 12b motor can be set -1000..1000.  This middle object adapts 12b to the low level driver  
  long _mmovec,_mturnc
  byte _lpin,_rpin
Pub _motor_start(_a,_b) 'initializes motors
  _lpin:=_a
  _rpin:=_b
  _mmovec:=_movec
  _mturnc:=_turnc
  _motor_cruise:=100
  _gainl:=256
  _gainr:=256
  _ngainl:=256
  _ngainr:=256
  _zerol:=1525
  _zeror:=1525
pub _motor_calibrate(_m,_tr)
  _mmovec:=3000*_m/100
  _mturnc:=2300*_tr/100
pub _motor_set_cruise(_x)
  _motor_cruise:=_x   
pub _motor_correct(_zl,_zr,_gl,_gr,_ngl,_ngr) 'corrects for difference in motor speed
  _zerol:=1525+_zl
  _zeror:=1525+_zr
  _gainl:=_gl
  _gainr:=_gr  
  _ngainl:=_ngl
  _ngainr:=_ngr  
pub _motor_mm(_mm,_turn)|_msec 'move and turn at cruise speed for specified distance
  _msec:=_mm*_mmovec/_motor_cruise
  if _msec<0
    _turn+=180 'reverse direction if msec is negative	
	_msec:=-_msec
  _turn:=(_turn+720)//360 'restrict to 0..360
  case _turn
    270..359:
      _motor_set(_motor_cruise*(_turn-315)/45,_motor_cruise)
    180..269:
      _motor_set(_motor_cruise*(_turn-225)/45,-_motor_cruise)
    91..179:

      _motor_set(-_motor_cruise,_motor_cruise*(135-_turn)/45)
    0..90:
      _motor_set(_motor_cruise,_motor_cruise*(45-_turn)/45)
  _move_finish(_msec)
pub _motor_deg(_deg,_dir) 'turn at positive and negative cruise speed for specified degrees
  if _deg<0
    _deg:=-_deg
	_dir:=-_dir
  if _dir>0
    _motor_set(_motor_cruise,-_motor_cruise)
  else
    _motor_set(-_motor_cruise,_motor_cruise)
  _move_finish(_deg*_mturnc/_motor_cruise)     
pub _motor_set(_left, _right) 'sets motor speeds
  if(_left>0)
	_servo.set(_rpin,_left*_gainL/512+_zeroL)
  else
	_servo.set(_rpin,_left*_ngainL/512+_zeroL)  
  if(_right>0)
	_servo.set(_lpin,-_right*_gainR/512+_zeroR)
  else
    _servo.set(_lpin,-_right*_ngainR/512+_zeroR)    
pub _motor_setbrake(_left, _right) 'sets brakes
  _coast:=_left
pri _move_finish(_msec)
  waitcnt(cnt+clkfreq/1000*_msec)  
  _servo.set(_lpin,-1)
  _servo.set(_rpin,-1)
