﻿//This "Testing Harness" requires that you place a "GuiBlocks.dll" with
//new gui blocks into the build directory of this program.
//The minimum of parameters is set, and block is only called with drawdynamic on form paint events
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Reflection;
using System.IO;

namespace GuiTest
{
    public partial class Form1 : Form
    {
       GUIBase.gui testBlock;
        private void loaditem()
        {
            testBlock = new GuiBlocks.joystickGUI();
            testBlock.updateParameter("font", new Font("arial", 10));
            testBlock.updateParameter("brush", new SolidBrush(Color.Red));
            testBlock.updateParameter("width", "100");
            testBlock.updateParameter("height", "100");
            testBlock.updateParameter("min", "0");
            testBlock.updateParameter("max", "100");
            testBlock.updateParameter("look", "yellow,FF00FF00,red");
            testBlock.updateParameter("setpoints", ".1,.1,.8.8,.1,.1");
            testBlock.rect = new Rectangle(100, 100, 60, 100);                     
            Refresh();
        }
        public Form1()
        {
            InitializeComponent();
            loaditem();                     
        }

        private void Form1_Paint(object sender, PaintEventArgs e)
        {
            if (testBlock!=null)
                testBlock.drawDynamic(e.Graphics );
        }        
    }
    }
    
    

