
#include <Arduino.h>
#include <VPmove.h>
//for tbug
#define SPI_MODE_MASK 0x0C  // CPOL = bit 3, CPHA = bit 2 on SPCR
#define SPI_CLOCK_MASK 0x03  // SPR1 = bit 1, SPR0 = bit 0 on SPCR
#define SPI_2XCLOCK_MASK 0x01  // SPI2X = bit 0 on SPSR
#define SPI_CLOCK_DIV2 0x04

const int _audiopin=5;
const int _motorlpin =5;//Left motor,5=pwm, 7=dir
const int _motorrpin =6;//Right motor,6=pwm,8=dir
const int _movec=3000;
const int _turnc=2300;
#include "VPSerial.h"
_VPSerial _vp;
#include "VPServo.h"
#include "VPServo2.h"
_VPServo _vps;
#include "or_arm.h"
_OR_arm _arm;
volatile int _c0=100;
volatile int _c1=100;
volatile int _c2=100;
volatile int _c3=100;
volatile int _c4=100;
volatile int _c5=500;
volatile int _c6=80;
volatile int _c7=80;
volatile int _c8=70;
volatile int _c9=66;
volatile int _c10=22;
volatile int _c11=500;
volatile int _c12=11;


int _cond(int a,int b,int c){
 switch(b){
 	 case 0:return a==c;
	 case 1:return a>c;
	 case 2:return a<c;
	 case 3:return a!=c;
	 case 4:return a && c;
	 case 5:return a || c;
 }
}


void (t1)() {//*(137,137) 
 while(1){
	while(!_c0);
	switch(_c0){
	case 1:
	  _arm.go(_c1,_c2,_c3,_c4,_c5);
	  break;
	case 2:	  
	  break;
	}
	_c0=0;
 }
}
void _arm_isr() {
	_arm.isr();
}
int main(void) { 
  timer0ISR=&_arm_isr;
  _arm.begin();
  init();  
  _vp.init(19200);
  addTask(t1);
  startTasks();  
  }

