
#include <Arduino.h>
#include <VPmove.h>
#include "or_scara.h"
_OR_scara _scara;
const int _audiopin=2;
const int _motorlpin =7;//Left motor,Hbridge uses 9 for speed control
const int _motorrpin =8;//Right motor,Hbridge uses 10 for speed control
const int _movec=3000;
const int _turnc=2300;
#include "VPSerial.h"
_VPSerial _vp;
#include "VPServo.h"
#include "VPServo2.h"
_VPServo _vps;
volatile int _c0=0;
volatile int _c1=600;
volatile int _c2=-400;
volatile int _c3=500;
volatile int _c4=100;
volatile int _c5=1000;
volatile int _c6=0;
volatile int _c7=5555;
volatile int _c8=100;
volatile int _c9=500;

int _cond(int a,int b,int c){
 switch(b){
 	 case 0:return a==c;
	 case 1:return a>c;
	 case 2:return a<c;
	 case 3:return a!=c;
	 case 4:return a && c;
	 case 5:return a || c;
 }
}

void (t2)() {//*(137,137)
 _scara.home(1000,0,0);   
 while(1){
	while(!_c0);
	_scara.speed(97); 
	switch(_c0){
	case 1:
	  _scara.target(_c1,_c2,_c3);
	  break;
	case 2:
	  _scara.home(_c1,_c2,_c3);
	  break;
	}
	_c0=0;
 }
}
void _scara_isr() {
	_scara.isr();
}
int main(void) { 
  timer0ISR=&_scara_isr;
  _scara.begin();
  init();  
  _vp.init(19200);
  addTask(t2);
  startTasks();  
}

