{<skip/>}
var
  long _motor_cruise,_zerol,_zeror,_gainl,_gainr,_coast
'a 12b motor can be set -1000..1000.  This middle object adapts 12b to the low level driver  
  long _mmovec,_mturnc
Pub _motor_start(_a,_b) 'initializes motors
  _mmovec:=_movec
  _mturnc:=_turnc
  _motor_cruise:=500
  _gainl:=256
  _gainr:=256
pub _motor_set_cruise(_x)
  _motor_cruise:=_x   
pub _motor_calibrate(_m,_tr)
  _mmovec:=_movec*_m/100
  _mturnc:=_turnc*_tr/100
pub _motor_correct(_zl,_zr,_gl,_gr,_ngl,_ngr) 'corrects for difference in motor speed
  _zerol:=_zl
  _zeror:=_zr
  _gainl:=_gl
  _gainr:=_gr  
pub _motor_mms(_mm,_turn,_ms)|_oldc 'move a distance for specified time
  _oldc:=_motor_cruise  
  _motor_cruise:=((||(_mm*_mmovec/_ms))#>1)<#1000 '_msec:=_mm*_mmovec/_motor_cruise
  _motor_mm(_mm,_turn)
  _motor_cruise:=_oldc
pub _motor_degs(_deg,_dir,_ms)|_oldc 'turn degrees for specified time  
  _oldc:=_motor_cruise
  _motor_cruise:=((||(_deg*_mturnc/_ms))#>1)<#1000 '_deg*_mturnc/_motor_cruise
  _motor_deg(_deg,_dir)
  _motor_cruise:=_oldc  
pub _motor_mm(_mm,_turn)|_msec 'move and turn at cruise speed for specified time
  _msec:=_mm*_mmovec/_motor_cruise  
  if _msec<0
    _turn+=180 'reverse direction if msec is negative	
	_msec:=-_msec
  _turn:=(_turn+720)//360 'restrict to 0..360
  case _turn
    270..359:
      _motor_set(_motor_cruise*(_turn-315)/45,_motor_cruise)
    180..269:
      _motor_set(_motor_cruise*(_turn-225)/45,-_motor_cruise)
    91..179:
      _motor_set(-_motor_cruise,_motor_cruise*(135-_turn)/45)
    0..90:
      _motor_set(_motor_cruise,_motor_cruise*(45-_turn)/45)
  _move_finish(_msec)
pub _motor_deg(_deg,_dir) 'turn at positive and negative cruise speed for specified time
  if _deg<0
    _deg:=-_deg
	_dir:=-_dir
  if _dir>0
    _motor_set(_motor_cruise,-_motor_cruise)
  else
    _motor_set(-_motor_cruise,_motor_cruise)
  _move_finish(_deg*_mturnc/_motor_cruise)     
pub _motor_set(_left, _right) 'sets motor speeds
  _tirmtr.setmotorpower(_left*_gainL/256-_zeroL,_right*_gainR/256-_zeroR)
pub _motor_setbrake(_left, _right) 'sets brakes
  _coast:=_left
pri _move_finish(_msec)
  waitcnt(cnt+clkfreq/1000*_msec)
  _motor_set(0,0)
  if(_coast) 
    return
  _tirmtr.setMotorBrake(true,true)